



#  Title screen font from - http://www.zee-3.com/pickfordbros/archive/bitmapfonts.php
#  "Feel free to use any of these fonts for whatever purpose you see fit."
#
#  Hello from Orange Free Sounds,
#  Stock audio - Free sound effects, loops and music.
#  There are no hidden costs or need to sign-up. 
#  License: The sound effect is permitted for non-commercial use under license âAttribution-NonCommercial 4.0 International (CC BY-NC 4.0)
#  http://www.orangefreesounds.com/

## Pokkito python
import upygame as upg
import umachine as pok
import gfx
import snd
import gc
import urandom as rand

card = gfx.card()
cursor = gfx.cursor()
title = gfx.title()
text = gfx.text()
myText = gfx.myText()

# Initialize sound
g_sound = upg.mixer.Sound()
g_sound.reset()
g_sound.play()


currentCard = 0
moveStyle = 0

grid_width = 7
grid_height = 7

gameMode = 0
moveMax = 0
numMoves = 0
firstRun=1
holdingWildcard= 0
cardsLeft = 0
#titleFrames = [0,1,2,2,3,0]
titleFrames = ['N','O','G','G','I','N']
titleOffset = [17,17,16,16,10,0]
goFrames=['G','A','M','E','O','V','E','R']
goFrame = [0,0,0,0,0,0,0,0]
goOffset = [10,10,10,10,10,10,10,10]
winFrames=['Y','O','U','W','O','N','!']

easeOutBounce = [
	0,0,0,1,3,4,6,9,12,15,
	19,23,27,32,37,43,49,55,62,69,
	77,85,93,102,111,120,130,140,151,162,
	173,185,197,210,222,236,249,250,244,237,
	232,226,221,216,212,208,205,202,199,197,
	195,193,192,191,191,191,191,192,193,195,
	196,199,201,205,208,212,216,221,226,231,
	237,243,250,254,250,248,245,243,241,240,
	239,239,239,239,239,241,242,244,246,249,
	251,254,253,252,251,251,251,251,252,253];

easeOutBack = [
	0,11,23,34,45,55,66,76,85,95,
	104,113,121,129,137,145,152,160,166,173,
	179,186,192,197,203,208,213,218,222,227,
	231,235,239,242,245,249,252,254,257,260,
	262,264,266,268,270,271,273,274,275,276,
	277,278,278,279,279,280,280,280,280,280,
	280,280,279,279,279,278,278,277,276,276,
	275,274,273,273,272,271,270,269,268,267,
	266,265,265,264,263,262,261,260,260,259,
	258,258,257,256,256,255,255,255,255,255];

#cardList = [56]
#cardFace = [56]
#             1,2,3,4,5,6,7,8,9,10, K, Q, J, W
moveCounts = [1,2,3,4,5,6,7,8,9,10,99,99, 0, 1]
cursorStyle =[1,1,1,1,1,1,1,1,1,1 , 2, 2, 1, 1]

lastCardX = [80,90,80,90]
lastCardY = [55,55,65,65]
lastJack = 0
animLength = 10
numWildCards = 0
wildOrder = [0,0,0,0]

cardList = [0 for x in range(56)]
cardFace = [0 for x in range(56)]
bounces = [0 for x in range (9)] # for titlescreen anim

def shuffle():
    sampleSize = 56

    doneShuffle = 0
    
    while doneShuffle == 0:

        s = len(cardList)
        for n in range(0, s):
            cardList[n] = n
        for n in range(0, s):
            rnd = rand.getrandbits(30)%s
            tmp = cardList[n]
            cardList[n] = cardList[rnd]
            cardList[rnd] = tmp
            cardFace[n] = 0

        cardFace[49] = 1
        cardFace[50] = 1
        cardFace[51] = 1
        cardFace[52] = 1
    
        doneShuffle = 1
        if cardList[49]%14 == 12 or cardList[50]%14 == 12 or cardList[51]%14 == 12 or cardList[52]%14 == 12:
            doneShuffle = 0




shuffle()

currentCard = 0
moveStyle = 0
moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
numMoves = 0
currentCard = cardList[cursor.x+7*cursor.y]%14
cur = cursorStyle[currentCard]

# movestyles
# 0 = anywhere
# 1 = horizontally
# 2 = vertically
# 3 = anywhere without collisison!


def easeInOut(t, b, c, d):
    
    # linear
    return ((t*c)//d)+b



def renderScreen():
    global cur
    global gameMode

    # Render screen
    screen.fill(0x7)
    
    # game mode for debug
    #text.draw(screen,0,0,gameMode)


    # current move
    text.draw(screen,12,78,(moveMax-numMoves)//10)
    text.draw(screen,16,78,(moveMax-numMoves)%10)
    text.draw(screen,25,78,10) # MOVES
    text.draw(screen,51,78,12) # LEFT
    # moves left
    text.draw(screen,85,5,(cardsLeft)//10)
    text.draw(screen,89,5,(cardsLeft)%10)
    text.draw(screen,80,11,11) # MOVES
    text.draw(screen,82,17,12) # LEFT
    
    # place holders
    cursor.draw(screen, 80,29,0)
    cursor.draw(screen, 90,29,0)
    cursor.draw(screen, 80,39,0)
    cursor.draw(screen, 90,39,0)
    cursor.draw(screen, 80,55,0)
    cursor.draw(screen, 90,55,0)
    cursor.draw(screen, 80,65,0)
    cursor.draw(screen, 90,65,0)

    a = 0
    # main grid
    for y in range(0,7):
        for x in range(0,7):
            card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[x+7*y])
            a+=1

    # last 4 cards
    for y in range(0,4):
        card.draw(screen, lastCardX[y], lastCardY[y], (cardList[a]%14)+1, cardList[a]//14,1)#cardFace[a]
        a+=1

    # wildCards
    for t in range(0,numWildCards):
        card.draw(screen, lastCardX[t], lastCardY[t]-26, 14, wildOrder[t],1)

    if holdingWildcard:
        cur = 1
        cursor.draw(screen, lastCardX[numWildCards-1], lastCardY[numWildCards-1]-26, cur)
        
    # Cursor
    cursor.draw(screen, cursor.x*10+5, cursor.y*10+5, cur)

    if cursor.x != cursor.sx or cursor.y != cursor.sy:
        card.draw(screen, cursor.x*10+5, cursor.y*10+5, 0,0,3)



def get_card_index(x, y):
	return ((y * grid_width) + x)

def get_card(x, y):
	index = get_card_index(x, y)
	return cardList[index]



def checkMoves(x,y,m):
    # I couldn't figure how to do this in a loop, so I didn't
    m0=0; m1=0; m2=0; m3=0; m4=0; m5=0; m6=0; m7=0; m8=0; m9=0

    if m1 == 4: m1=0; m2+=1
    if m2 == 4: m2=0; m3+=1
    if m3 == 4: m3=0; m4+=1
    if m4 == 4: m4=0; m5+=1
    if m5 == 4: m5=0; m6+=1
    if m6 == 4: m6=0; m7+=1
    if m7 == 4: m7=0; m8+=1
    if m8 == 4: m8=0; m9+=1

    #if cardFace[cursor.x+7*(cursor.y-1)] == 0:
    


def flipCard(x,y):
    a = x+7*y
    g_sound.play_sfx(snd.snd_flip, len(snd.snd_flip), True)
    for t in range(0,7):
        renderScreen()
        card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[a]+4+t)
        # Update the display
        upg.display.flip()


def unFlipCard(x,y):
    a = x+7*y
    for t in range(0,5):
        renderScreen()
        card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[a]+4+t)
        # Update the display
        upg.display.flip()
    cardFace[a] = 4
    dirtyRect = upg.Rect(x*10+5, y*10+5, 7, 6)
    screen.fill(7, dirtyRect)

def unFlipRow(y):
    for t in range(0,5):
        renderScreen()
        for x in range(0,7):
            a = x+7*y
            card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[a]+4+t)
        # Update the display
        upg.display.flip()
    for x in range(0,7):
        a = x+7*y
        cardFace[a] = 4
    #dirtyRect = upg.Rect(x*10+5, y*10+5, 7, 6)
    #screen.fill(7, dirtyRect)


def checkUp():
    if cursor.y == 0: return 0
    if holdingWildcard==1: return 1
    if cur == 3: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[cursor.x+7*(cursor.y-1)] == 0:
        if moveStyle != 1:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 2:
            if numMoves < moveMax:
                return 1
    return 0

def checkDown():
    if cursor.y == 6: return 0
    if holdingWildcard==1: return 1
    if cur == 3: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[cursor.x+7*(cursor.y+1)] == 0:
        if moveStyle != 1:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 2:
            if numMoves < moveMax:
                return 1
    return 0

def checkLeft():
    if cursor.x == 0: return 0
    if holdingWildcard==1: return 1
    if cur == 4: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[(cursor.x-1)+7*cursor.y] == 0:
        if moveStyle != 2:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 1:
            if numMoves < moveMax:
                return 1
    return 0

def checkRight():
    if cursor.x == 6: return 0
    if holdingWildcard==1: return 1
    if cur == 4: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[(cursor.x+1)+7*cursor.y] == 0:
        if moveStyle != 2:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 1:
            if numMoves < moveMax:
                return 1
    return 0

# Setup the screen.
screen = upg.display.set_mode()


def checkJack(xx,yy):
    global animLength
    global lastJack
    # got a jack?
    if cardList[xx+7*yy]%14 == 12:
        a = cardList[xx+7*yy] 
        cx = xx*10+5
        cy = yy*10+5
        g_sound.play_sfx(snd.snd_collect, len(snd.snd_collect), True)

        for t in range(0,animLength):
            x = easeInOut(t, cx, lastCardX[lastJack]-cx, animLength)
            y = easeInOut(t, cy, lastCardY[lastJack]-cy, animLength)
            x1 = lastCardX[lastJack]+(cx-x)
            y1 = lastCardY[lastJack]+(cy-y)
            renderScreen()
                            
            dirtyRect = upg.Rect(cx, cy, 9, 8)
            screen.fill(0x7, dirtyRect)
            dirtyRect = upg.Rect(lastCardX[lastJack], lastCardY[lastJack], 9, 8)
            screen.fill(0x7, dirtyRect)

            card.draw(screen, x, y, (a%14)+1, a//14, cardFace[xx+7*yy])
            card.draw(screen, x1, y1, (cardList[lastJack+49]%14)+1, cardList[lastJack+49]//14, cardFace[lastJack+49])
            upg.display.flip()

        temp = cardList[xx+7*yy]
        cardList[xx+7*yy] = cardList[49 + lastJack]
        cardList[49 + lastJack] = temp
        lastJack +=1

def checkWild(xx,yy):
    global animLength
    global numWildCards
    # got a wildcard?
    if cardList[xx+7*yy]%14 == 13:
        a = cardList[xx+7*yy] 
        cx = xx*10+5
        cy = yy*10+5
        g_sound.play_sfx(snd.snd_collect, len(snd.snd_collect), True)
        for t in range(0,animLength):
            x = easeInOut(t, cx, lastCardX[numWildCards]-cx, animLength)
            y = easeInOut(t, cy, (lastCardY[numWildCards]-26)-cy, animLength)
            renderScreen()
                            
            card.draw(screen, x, y, (a%14)+1, a//14, cardFace[xx+7*yy])
            upg.display.flip()
                
        wildOrder[numWildCards]=a//14
        numWildCards +=1




def newGame():
    global gameMode
    global firstRun
    global numWildCards
    global cardsLeft
    global lastJack

    lastJack=0
    numWildCards = 0
    cursor.sx = rand.getrandbits(30)%7
    cursor.sy = rand.getrandbits(30)%7
    gameMode = 1
    shuffle()
    cursor.x = cursor.sx
    cursor.y = cursor.sy
    cardFace[cursor.x+7*cursor.y] = 1
    firstRun=1
    holdingWildcard=0
    cardsLeft = 49

titleAnim = 0
titleFrame = [0,0,0,0,0,0]
goFrame = [0,0,0,0,0,0,0,0]
frameNumber = 0


txtScroll = 5
txtScrollDir = 0
def instructionsScreen():
    global gameMode
    global txtScroll
    global txtScrollDir

    bgCol = 15
    titleCol = 9
    textCol = 8
    bulletCol = 13

    txtScroll += txtScrollDir
    if txtScroll > 5:
        txtScroll = 5;
    if txtScroll < -170:
        txtScroll = -170;


    # Render screen
    screen.fill(bgCol)

    pok.draw_text(2, txtScroll + 3, "________", titleCol)
    pok.draw_text(4, txtScroll + 3, "________", titleCol)
    pok.draw_text(2, txtScroll + 2, "HOW TO PLAY", titleCol)

    linePos = txtScroll + 10
    pok.draw_text(2, linePos, "Turn over all of the tiles", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "on the game board.", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "However, you must move", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "exactly the number of", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "spaces shown on the", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "tile.", textCol)
    linePos += 7
    pok.draw_text(2, linePos + 1, "___", titleCol)
    pok.draw_text(4, linePos + 1, "__", titleCol)
    pok.draw_text(2, linePos + 0, "KEY", titleCol)
    linePos += 8
    pok.draw_text(2, linePos, "1-10:Move this many tiles.", textCol)
    pok.draw_text(2, linePos, "1-10", bulletCol)
    linePos += 8
    pok.draw_text(2, linePos, "J:Take the top tile from", textCol)
    pok.draw_text(2, linePos, "J:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "   The spares pile.", textCol)
    linePos += 8
    pok.draw_text(2, linePos, "Q:Pick any tile in the", textCol)
    pok.draw_text(2, linePos, "Q:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "  same row or column.", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "  However, all tiles in the", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "  row or column will be", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "  turned.", textCol)
    linePos += 8
    pok.draw_text(2, linePos, "K:Same as Q, but only the", textCol)
    pok.draw_text(2, linePos, "K:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "  selected tile will be", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "  turned.", textCol)
    linePos += 8
    pok.draw_text(2, linePos, "!:Move 1 space. BUT! you", textCol)
    pok.draw_text(2, linePos, "!:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "   also get a free turn*.", textCol)
    linePos += 7
    linePos += 7

    pok.draw_text(2, linePos, "* Free turn will allow you", textCol)
    pok.draw_text(2, linePos, "*", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "   to move anywhere on", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "   the gameboard.", textCol)
    linePos += 21

    pok.draw_text(2, linePos + 3, "________", titleCol)
    pok.draw_text(4, linePos + 3, "________", titleCol)
    pok.draw_text(2, linePos + 2, "CONTROLS", titleCol)
    linePos += 10
    pok.draw_text(2, linePos, "D-PAD:Move around the", textCol)
    pok.draw_text(2, linePos, "D-PAD:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "   Gameboard.", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "A:Flip the current card.", textCol)
    pok.draw_text(2, linePos, "A:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "B:Use free turn, or", textCol)
    pok.draw_text(2, linePos, "B:", bulletCol)
    linePos += 7
    pok.draw_text(2, linePos, "  reset current turn.", textCol)
    linePos += 7
    pok.draw_text(2, linePos, "C:Start new game.", textCol)
    pok.draw_text(2, linePos, "C:", bulletCol)
    linePos += 7

    dirtyRect = upg.Rect(0, 0, 109, 6)
    screen.fill(bgCol, dirtyRect)
    


    # Update the display
    upg.display.flip()

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.K_DOWN:
                txtScrollDir = -1
            if eventtype.key == upg.K_UP:
                txtScrollDir = 1
            if eventtype.key == upg.BUT_A:
                gameMode = 0
                txtScroll = 5
            if eventtype.key == upg.BUT_B:
                gameMode = 0    
                txtScroll = 5
            if eventtype.key == upg.BUT_C:
                gameMode = 0    
                txtScroll = 5

        if eventtype.type == upg.KEYUP:
            txtScrollDir = 0



def titleScreen():
    global gameMode
    global titleAnim
    global frameNumber

    # keep generating a random number as rand.seed() doesn't seem to do anything
    rnd = rand.getrandbits(30)
    
    titleHeight = 52
    y = titleHeight-16
    
    bounces[0] = titleHeight # N
    bounces[1] = titleHeight # O
    bounces[2] = titleHeight # G
    bounces[3] = titleHeight # G
    bounces[4] = titleHeight # I
    bounces[5] = titleHeight # N
    
    if titleAnim==0:
        #for t in range(0,50):
        while titleFrame[5] != 98:
            frameNumber += 1
            # look up table for bounce effect, math is slow
            x=9
            # Render screen
            screen.fill(0x7)
            
            pok.draw_text(10, titleHeight + 8, "A - Start Game", 15)
            pok.draw_text(10, titleHeight + 16, "B - Instructions", 15)
        
            pok.draw_text(10, 8, "Spring 2019 Pokitto", 15)
            pok.draw_text(10,16, "MicroPython Contest", 15)
            
            
            for x1 in range(0,6):
        
                bounces[x1] = (easeOutBounce[titleFrame[x1]]*titleHeight)//256
                bounces[x1] -= 16
                if frameNumber > x1*4:
                    titleFrame[x1]+=2
                    if titleFrame[x1] > 98:
                        titleFrame[x1]=98
                #print(titleFrame[x1])
                title.draw(screen,x,bounces[x1],titleFrames[x1])
                x += titleOffset[x1]

            # Update the display
            upg.display.flip()
        titleAnim=1    
    

    # Render screen
    screen.fill(0x7)

    x=9
    for x1 in range(0,6):
        title.draw(screen,x,y-1,titleFrames[x1])
        x += titleOffset[x1]


    pok.draw_text(10, titleHeight + 8, "A - Start Game", 15)
    pok.draw_text(10, titleHeight + 16, "B - Instructions", 15)

    pok.draw_text(10, 8, "Spring 2019 Pokitto", 15)
    pok.draw_text(10,16, "MicroPython Contest", 15)


    # Update the display
    upg.display.flip()

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.BUT_A:
                for x1 in range(0,6):
                    titleFrame[x1]=0
                frameNumber=0
                newGame()    
            if eventtype.key == upg.BUT_B:
                gameMode = 2
                for x1 in range(0,6):
                    titleFrame[x1]=0
                frameNumber=0

goAnim = 1

def gameOver():
    global gameMode
    global frameNumber
    global goAnim

    titleHeight = 52
    y = 16

    bounces[0] = titleHeight # G
    bounces[1] = titleHeight # A
    bounces[2] = titleHeight # M
    bounces[3] = titleHeight # E
    bounces[4] = titleHeight # O
    bounces[5] = titleHeight # V
    bounces[6] = titleHeight # E
    bounces[7] = titleHeight # R

    renderScreen()

    #text.draw(screen,0,0,(frameNumber)//10)
    #text.draw(screen,4,0,(frameNumber)%10)

    if frameNumber == 0:
        g_sound.play_sfx(snd.snd_fail, len(snd.snd_fail), True)

    if goAnim == 0:
        x=3
        for x1 in range(0,8):
            title.draw(screen,x,bounces[x1]-y-1,goFrames[x1])
            x+=11
            if x1==3:
                x+=11
    
        pt=['P','R','E','S','S',' ','A']
        for t in range(0,len(pt)):
            myText.draw(screen,27+(t*8),60,pt[t])


    if goAnim == 1:
        frameNumber +=1
        x=3
        for x1 in range(0,8):
            bounces[x1] = (easeOutBounce[goFrame[x1]]*titleHeight)//256
            title.draw(screen,x,bounces[x1]-y,goFrames[x1])
            x+=11
            if x1==3:
                x+=11
            if frameNumber > x1*4:
                goFrame[x1]+=2
                if goFrame[x1] > 98:
                    goFrame[x1]=98

    if goFrame[7] & goFrame[6] == 98:
        goAnim = 0
    


    # Update the display
    upg.display.flip()

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.BUT_A:
                gameMode=0    
                for x1 in range(0,8):
                    goFrame[x1]=0
                frameNumber=0
                goAnim=1

def gameWinner():
    global gameMode
    global frameNumber
    global goAnim

    titleHeight = 52
    y = 16

    bounces[0] = titleHeight # Y
    bounces[1] = titleHeight # O
    bounces[2] = titleHeight # U
    bounces[3] = titleHeight # W
    bounces[4] = titleHeight # I
    bounces[5] = titleHeight # N
    bounces[6] = titleHeight # !

    renderScreen()

    #text.draw(screen,0,0,(frameNumber)//10)
    #text.draw(screen,4,0,(frameNumber)%10)

    if frameNumber == 0:
        g_sound.play_sfx(snd.snd_fanfare, len(snd.snd_fanfare), True)

    if goAnim == 0:
        x=5
        for x1 in range(0,7):
            title.draw(screen,x,bounces[x1]-y-1,winFrames[x1])
            x+=12
            if x1==2:
                x+=12
    
        pt=['P','R','E','S','S',' ','A']
        for t in range(0,len(pt)):
            myText.draw(screen,27+(t*8),56,pt[t])


    if goAnim == 1:
        frameNumber +=1
        x=5
        for x1 in range(0,7):
            bounces[x1] = (easeOutBounce[goFrame[x1]]*titleHeight)//256
            title.draw(screen,x,bounces[x1]-y,winFrames[x1])
            x+=12
            if x1==2:
                x+=12
            if frameNumber > x1*4:
                goFrame[x1]+=2
                if goFrame[x1] > 98:
                    goFrame[x1]=98

    if goFrame[5] & goFrame[6] == 98:
        goAnim = 0
    


    # Update the display
    upg.display.flip()

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.BUT_A:
                gameMode=0    
                for x1 in range(0,8):
                    goFrame[x1]=0
                frameNumber=0
                goAnim=1




def gameLoop():
    global moveMax
    global currentCard
    global moveStyle
    global numMoves
    global cur
    global animLength
    global lastJack
    global numWildCards
    global holdingWildcard
    global cardsLeft
    global gameMode

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.K_RIGHT:
                if checkRight()!= 0:
#                    g_sound.play_sfx(snd.snd_beep, len(snd.snd_beep), True)
                    if moveMax != 99: numMoves += 1
                    cursor.x += 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 1
                        if cur != 4:
                            cur = 3
            if eventtype.key == upg.K_LEFT:
                if checkLeft()!= 0:
#                    g_sound.play_sfx(snd.snd_beep, len(snd.snd_beep), True)
                    if moveMax != 99: numMoves += 1
                    cursor.x -= 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 1
                        if cur != 4:
                            cur = 3
            if eventtype.key == upg.K_UP:
                if checkUp() != 0:
#                    g_sound.play_sfx(snd.snd_beep, len(snd.snd_beep), True)
                    if moveMax != 99: numMoves += 1
                    cursor.y -= 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 2
                        if cur != 3:
                            cur = 4
            if eventtype.key == upg.K_DOWN:
                if checkDown() != 0:
#                    g_sound.play_sfx(snd.snd_beep, len(snd.snd_beep), True)
                    if moveMax != 99: numMoves += 1
                    cursor.y += 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 2
                        if cur != 3:
                            cur = 4

            if eventtype.key == upg.BUT_A:
                if cardFace[cursor.x+7*cursor.y] != 1:
                    if numMoves == moveMax or moveStyle != 0 or holdingWildcard:

                        cursor.sx = cursor.x
                        cursor.sy = cursor.y

                        if currentCard == 11 and holdingWildcard == 0:
                            for y in range(0,7):
                                if moveStyle == 2:
                                    if cardFace[cursor.x+7*y] != 1:
                                        flipCard(cursor.x,y)
                                        cardFace[cursor.x+7*y] = 1
                                        cardsLeft -=1
                                        checkJack(cursor.x,y)
                                        checkWild(cursor.x,y)
                                if moveStyle == 1:
                                    if cardFace[y+7*cursor.y] != 1:
                                        flipCard(y,cursor.y)
                                        cardFace[y+7*cursor.y] = 1
                                        cardsLeft -=1
                                        checkJack(y,cursor.y)
                                        checkWild(y,cursor.y)
    
                        # extra check in case current card was flipped above
                        if cardFace[cursor.x+7*cursor.y] != 1:
                            flipCard(cursor.x,cursor.y)
                            cardFace[cursor.x+7*cursor.y] = 1
                            cardsLeft -=1
                            checkJack(cursor.x,cursor.y)
                            checkWild(cursor.x,cursor.y)

                        if holdingWildcard:
                            holdingWildcard = 0
                            numWildCards -=1

    
                        moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
                        numMoves = 0
                        moveStyle = 0
                        currentCard = cardList[cursor.x+7*cursor.y]%14
                        cur = cursorStyle[currentCard]
                        
                        for y in range(0,7):
                            for x in range(0,7):
                                if cardFace[x+7*y] == 2:
                                    cardFace[x+7*y] = 0
                        

                # Collect all freed memory. 
                #gc.collect()    
                # Print free memory amount
                #print ("free:",gc.mem_free())
                            
            if eventtype.key == upg.BUT_B:
                if cursor.x == cursor.sx and cursor.y == cursor.sy:
                    if numWildCards != 0:
                        holdingWildcard = 1
                        moveMax = 99
                else:
                    cursor.x = cursor.sx
                    cursor.y = cursor.sy
                    numMoves = 0
                    moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
                    moveStyle = 0
                    currentCard = cardList[cursor.x+7*cursor.y]%14
                    cur = cursorStyle[currentCard]
                    for y in range(0,7):
                        for x in range(0,7):
                            if cardFace[x+7*y] == 2:
                                cardFace[x+7*y] = 0

            if eventtype.key == upg.BUT_C:
                # put a menu here later
                #for y in range(0,7):
                #    unFlipRow(y)
                frameNumber=0
                gameMode=3


    if cardFace[cursor.x+7*cursor.y] == 0 and moveStyle == 0 and moveMax != 99:
        cardFace[cursor.x+7*cursor.y] = 2

    renderScreen()
    # Update the display
    upg.display.flip()


    if cardsLeft == 0:
        gameMode=4

while upg.event.poll() == upg.KEYDOWN:
    rnd = rand.getrandbits(30) # something to do in while loop

# The main loop. 
while True:
    if gameMode == 0:
        titleScreen()
    if gameMode == 1:
        if firstRun==1:
            frameNumber=0
            checkJack(cursor.x,cursor.y)
            checkWild(cursor.x,cursor.y)
            cardsLeft -=1
            moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
            numMoves = 0
            moveStyle = 0
            currentCard = cardList[cursor.x+7*cursor.y]%14
            cur = cursorStyle[currentCard]
            firstRun=0
            for x1 in range(0,6):
                titleFrame[x1]=0

        gameLoop();
        frameNumber=0
        titleAnim=0
    
    if gameMode == 2:
        instructionsScreen()
        frameNumber=0
        titleAnim=0

    if gameMode == 3:
        gameOver()

    if gameMode == 4:
        gameWinner()

#    print(gameMode)
